/**
	@file cstrans.h
	@brief e[uWϊ
	@author Atsushi WATANABE <atusi_w@roboken.esys.tsukuba.ac.jp> <atusi_w@doramanjyu.com> 
 */

#ifndef __CSTRANS_H__
#define __CSTRANS_H__

typedef float v4sf __attribute__ ((vector_size(16),aligned(16)));
typedef float v2sf __attribute__ ((vector_size(8),aligned(8)));

// ACgtfloat
typedef union
{
	v2sf v;
	struct {
		float x;
		float y;
	};
	struct {
		float theta;
		float r;
	};
	float array[ 2 ];
} vector __attribute__((aligned(8)));

typedef union
{
	v4sf m;
	v2sf v[2];
	float array[ 4 ];
} matrix __attribute__((aligned(16)));


typedef struct _cstrans{
	float *sin;
	float *cos;
	int resolution;
} CSTrans __attribute__((aligned(4)));

void cstrans_polar2rect( CSTrans *cst, vector *src, vector *dest, int len );
void cstrans_rotate( CSTrans *cst, vector *src, vector *dest, int len, int step );
void cstrans_free( CSTrans *table );
CSTrans *cstrans_init( int resolution );

#endif
